#include "os.h"
#include "kheap.h"
#include "task.h"

extern page_directory_t* current_directory;
extern task_t* current_task;
extern task_t* ready_queue;
extern tss_entry_t tss_entry;
extern heap_t* kheap;
//extern ULONG file_data_start;

void moo()
{
  while(TRUE)
  {
      settextcolor(2,0);
      printformat("MOO %d", getpid()); // <-- cow
      settextcolor(15,0);
  }
}

void baa()
{
  while(TRUE)
  {
      settextcolor(4,0);
      printformat("BAA %d", getpid()); // <- sheep
      settextcolor(15,0);
  }
}

void surprise(ULONG a, ULONG b) // <- function with 2 arguments
{
  asm volatile ("push %0" :/* no output registers */: "r" (b));
  asm volatile ("push %0" :/* no output registers */: "r" (a));
  while(TRUE)
  {
      asm volatile ("call _settextcolor");
      printformat("%d", getpid());
      settextcolor(15,0);
  }
}

void test()                    // <- program from outside "loaded" by incbin ...
{
  while(TRUE)
  {
      asm volatile ("call _file_data_start");
      printformat("%d", getpid());
      settextcolor(15,0);
  }
}

int main()
{
    printformat("Welcome to PrettyOS 0.08\n");
    // GDT, IDT, ISRS, IRQ, timer, keyboard, paging, interrupts, multitasking
    gdt_install();
    idt_install();
    isrs_install();
    irq_install();
    initODA();
    timer_install();
    keyboard_install();
    sti();
    paging_install();
    kheap = create_heap(KHEAP_START, KHEAP_START+KHEAP_INITIAL_SIZE, KHEAP_MAX, 0, 0);
    tasking_install();

    task_t* task2 = create_task(moo);
    task_t* task3 = create_task(baa);
    task_t* task4 = create_task2(surprise,4,2);
    task_t* task5 = create_task(test);

    k_clear_screen();
    log_task_list();
    sleepSeconds(5);

    pODA->ts_flag = 1;

    k_clear_screen();

    while(TRUE)
    {
        settextcolor(15,0);
        printformat("%d", getpid());
    }
    return 0;
}
